#!/usr/bin/perl

use strict;
use warnings;

my @m_NL = qw(januari februari maart april mei juni juli augustus september oktober november december);
my @m_EN = qw(January February March April May June July August September October November December);
my @d_NL = qw(zondag maandag dinsdag woensdag donderdag vrijdag zaterdag zondag);
my @d_EN = qw(Sunday Monday Tuesday Wednesday Thursday Friday Saturday Sunday);

use Time::Local;
my $now = time;
my @tm = localtime($now);
my $year = 1900 + $tm[5];
$tm[3] = 1;

my $then = timelocal(0, 0, 0, 1 + 7 * (THE_OCC - 1), $tm[4], $year);
while ( $then <= $now ) {
    last if $ENV{NOTNEXT};
    $year++, $tm[4] = 0 if ++$tm[4] > 11;
    $then = timelocal(0, 0, 0, 1 + 7 * (THE_OCC - 1), $tm[4], $year);
}
@tm = localtime($then);
my $wday = $tm[6];
$tm[3] += 7 if $wday > THE_DAY;
$tm[3] -= ($wday - THE_DAY);

my $date_NL = $d_NL[THE_DAY] . " " . $tm[3] . " " . $m_NL[$tm[4]];
my $date_EN = $d_EN[THE_DAY] . ", " . $m_EN[$tm[4]] . " " . $tm[3];

use Mail::Mailer;

my $m = new Mail::Mailer;

my %hdrs;
my $open = 0;
while ( <DATA> ) {
    s/\{date_NL\}/$date_NL/g;
    s/\{date_EN\}/$date_EN/g;
    s/\{year\}/$year/g;

    unless ( $open ) {
	unless ( /\S/ ) {
	    while ( my($k,$v) = each(%hdrs) ) {
		print STDERR $k, ": ", $v, "\n";
	    }
	    print STDERR " -- Ok? ";
	    my $ans = <>;
	    die("Aborted\n") unless $ans =~ /^y/i;
	    $m->open(\%hdrs);
	    #undef $m;
	    #open($m, '>&STDOUT');
	    #print $m join("\n", map { +"$_: $hdrs{$_}" } keys %hdrs);
	    $open++;
	    next;
	}
	m/(.*?):\s*(.*)/;
	$hdrs{$1} = $2;
	next;
    }
    print $m $_;
}
$m->close;

1;
